//
// Created by welsch on 25.06.18.
//

#ifndef ROOFIT_TEST_DATAMANAGER_H
#define ROOFIT_TEST_DATAMANAGER_H

#include <vector>
#include <string>
#include <memory>
#include <map>

#include "TFile.h"
#include "TTree.h"

#include "RooDataSet.h"
#include "RooArgSet.h"
#include "RooRealVar.h"


class DataManager {
private:

    void load_trees_from_file(const std::string &tree_name);

    std::string m_filedir;
    std::vector<std::string> m_file_names;
    std::shared_ptr<TFile> m_tfile;
    std::map<std::string, std::shared_ptr<TTree>> m_mtrees;

public:
    DataManager() = default;
    DataManager(std::string filedir, std::vector<std::string> file_names);

    std::map<std::string, std::shared_ptr<RooDataSet>> load_datasets_from_file(
            std::string var_set_name,
            RooArgSet var_set,
            RooRealVar weight,
            const std::string &tree_name);

};


#endif //ROOFIT_TEST_DATAMANAGER_H
