//
// Created by welsch on 18.06.18.
//

#include "FitUtils.h"

#include "TCollection.h"

#include "RooAbsPdf.h"
#include "RooRealVar.h"
#include "RooDataSet.h"
#include "RooFitResult.h"


#include "TGraphErrors.h"
#include "TH1F.h"
std::map<TString, std::shared_ptr<TTree>> load_ttrees(TFileManager fmanger,
                                                      std::vector<TString> vfile_names,
                                                      TString tree_name) {
    std::map<TString, std::shared_ptr<TTree>> mtrees;
    for(auto const &file_name : vfile_names) {
        auto file = fmanger.get_TFile(file_name);
        file->cd();
        std::shared_ptr<TTree> tree((TTree*) file->Get(tree_name));
        mtrees.emplace(file_name, tree);
    }
    return mtrees;
};

RooAddPdf create_template(const std::vector<TString> &vtemplate_names,
                          const std::map<TString, std::shared_ptr<TTree>> &mtrees) {

}

void linearity_check(RooAbsPdf &model_pdf,
                     RooAbsPdf &sig_pdf,
                     RooAbsPdf &bkg_pdf,
                     RooRealVar &observable,
                     RooRealVar param) {
    const int nbkg = 3000;
    std::vector<int> vnsig {50, 100, 200, 300, 400, 500, 600, 800, 1000, 1200};
    std::vector<int> vensig {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    std::vector<double> vfit_nsig;
    std::vector<double> efit_nsig;

    for(const auto &nsig : vnsig) {
        TH1F hfit_nsig("hfit_nsig", "Fitted Signal Events",
                       25, nsig-0.5*nsig, nsig+0.5*nsig);
        for(int i = 0; i<10; i++) {
            RooDataSet *mcsig = sig_pdf.generate(observable, nsig);
            mcsig->append(*bkg_pdf.generate(observable, nbkg));

            model_pdf.fitTo(*mcsig, RooFit::Extended(kTRUE), RooFit::Silence(2));
            hfit_nsig.Fill(param.getVal());
            std::cout<<param.getVal()<< std::endl;
        }
        vfit_nsig.push_back(hfit_nsig.GetMean());
        efit_nsig.push_back(hfit_nsig.GetStdDev());
    }
    for(const auto & fitnsig : vfit_nsig) std::cout << fitnsig << std::endl;
}