//
// Created by welsch on 25.06.18.
//

#ifndef ROOFIT_TEST_TEMPLATEFITTER_H
#define ROOFIT_TEST_TEMPLATEFITTER_H


#include <memory>
#include <string>
#include <tuple>

#include "RooDataSet.h"
#include "RooHistPdf.h"
#include "RooRealVar.h"
#include "RooAddPdf.h"

#include "TGraphErrors.h"


class TemplateFitter {
public:
    TemplateFitter() = default;
    TemplateFitter(std::shared_ptr<RooRealVar> observable,
                   const std::string &sig,
                   const std::vector<std::string> &vbkg,
                   const std::map<std::string, std::shared_ptr<RooDataSet>> &mds);

    void do_linearity_check(double from, double to, int nsteps);

private:
    std::shared_ptr<RooRealVar> m_observable;
    std::shared_ptr<RooAddPdf> m_model;

    std::string m_sig;
    std::vector<std::string> m_vbkg;

    std::map<std::string, std::shared_ptr<RooDataSet>> m_mds;
    std::map<std::string, std::shared_ptr<RooHistPdf>> m_mtemp;
    std::map<std::string, double> m_mexp_yields;
    std::map<std::string, std::shared_ptr<RooRealVar>> m_myields;

    void create_templates();
    void create_model();
    void reset_yields();
    void set_yield(std::string, double);
    void fit_linearity_check(TGraphErrors);

    std::pair<double, double> do_toys(double, int);
};


#endif //ROOFIT_TEST_TEMPLATEFITTER_H
