//
// Created by welsch on 25.06.18.
//

#include <vector>
#include <string>

#include "DataManager.h"
#include "TemplateFitter.h"

#include "Belle2Style.h"

#include "RooArgSet.h"
#include "RooRealVar.h"

using namespace std;

int main() {

    SetBelle2Style();

    cout << "Missing Mass Fit" << endl;

    // setup DataManager to load the RooFit DataSets from given ROOT files
    string filedir{"/usr/users/welsch/workspace/TestRooFit"};
    vector<string> vfile_names{"PI0Signal", "PI0xulnu", "PI0remaining"};
    DataManager dm(filedir, vfile_names);

    auto missing_mass = std::make_shared<RooRealVar>("missing_mass", "missing_mass", -2, 5);
    RooRealVar weight("weight", "weight", -5,5);


    auto mdata_set = dm.load_datasets_from_file(
            "missingMass",
            RooArgSet(*missing_mass, weight),
            weight,
            "mytree");

    TemplateFitter TF(missing_mass, "PI0Signal", {"PI0xulnu", "PI0remaining"}, mdata_set);
    TF.do_linearity_check(100, 500, 5);
}